Loading...
Searching...
No Matches
Fitness.idl
/* SPDX-License-Identifier: BSD-3-Clause */
/*
* Copyright 2010 Raritan Inc. All rights reserved.
*/
/** %Fitness Daemon */
module fitness {
/** %Fitness Daemon interface */
interface Fitness {
/** The value/worstValue/rawValue is invalid (e.g. not initialized). */
constant int FLAG_VALUE_INVALID = 0x1;
/** The value/rawValue is out-dated. */
constant int FLAG_VALUE_OLD = 0x2;
/** Violating the threshold is a critical event. */
constant int FLAG_ENTRY_CRITICAL = 0x4;
/** An entry in the reliability database */
structure DataEntry {
string id; /**< unique id of the entry */
int value; /**< normalized value */
int maxValue; /**< maximum possible normalized value */
int worstValue; /**< worst normalized value seen yet */
int thresholdValue; /**< normalized threshold value */
long rawValue; /**< raw value */
int flags; /**< flags (see above) */
};
/**
* An entry in the reliability error log
*
* An error log entry is made when the normalized value of a data entry
* drops below the normalized threshold value.
*/
structure ErrorLogEntry {
string id; /**< id of the associated data entry */
int value; /**< normalized value */
int thresholdValue; /**< normalized threshold value */
long rawValue; /**< raw value */
int powerOnHours; /**< power on hours when error occured */
time timeStampUTC; /**< UTC time stamp when error occured */
};
/**
* @brief Returns the fitness data entries.
*
* The count of entries depends on the device. For example a PDU each
* sub controller currently has 3 entries + 2 entries per relay. The
* data is updated only once or twice a minute.
*
* @return -- the vector with the fitness data entries
*/
vector<DataEntry> getDataEntries();
/**
* @brief Returns the error log index range.
*
* @param firstIndex -- the first valid index
* @param entryCount -- the count of entries in the error log
*/
void getErrorLogIndexRange(out int firstIndex, out int entryCount);
/**
* @brief Returns the error log.
*
* If the startIndex is smaller than the first index in the log than
* the count of returned entries is smaller (or even 0) as well.
*
* @param startIndex -- the index of the first entry to return
* @param count -- the count of entries starting from the startIndex
* @return -- the vector with the error log entries
*/
vector<ErrorLogEntry> getErrorLogEntries(in int startIndex, in int count);
};
}
fitness::Fitness
Fitness Daemon interface
Definition Fitness.idl:10
fitness::Fitness::getDataEntries
vector< DataEntry > getDataEntries()
Returns the fitness data entries.
fitness::Fitness::getErrorLogEntries
vector< ErrorLogEntry > getErrorLogEntries(in int startIndex, in int count)
Returns the error log.
fitness::Fitness::getErrorLogIndexRange
void getErrorLogIndexRange(out int firstIndex, out int entryCount)
Returns the error log index range.
fitness
Fitness Daemon
Definition Fitness.idl:7
fitness::Fitness::DataEntry
An entry in the reliability database.
Definition Fitness.idl:22
fitness::Fitness::DataEntry::id
string id
unique id of the entry
Definition Fitness.idl:23
fitness::Fitness::DataEntry::maxValue
int maxValue
maximum possible normalized value
Definition Fitness.idl:25
fitness::Fitness::DataEntry::thresholdValue
int thresholdValue
normalized threshold value
Definition Fitness.idl:27
fitness::Fitness::DataEntry::value
int value
normalized value
Definition Fitness.idl:24
fitness::Fitness::DataEntry::rawValue
long rawValue
raw value
Definition Fitness.idl:28
fitness::Fitness::DataEntry::flags
int flags
flags (see above)
Definition Fitness.idl:29
fitness::Fitness::DataEntry::worstValue
int worstValue
worst normalized value seen yet
Definition Fitness.idl:26
fitness::Fitness::ErrorLogEntry
An entry in the reliability error log.
Definition Fitness.idl:38
fitness::Fitness::ErrorLogEntry::timeStampUTC
time timeStampUTC
UTC time stamp when error occured.
Definition Fitness.idl:44
fitness::Fitness::ErrorLogEntry::rawValue
long rawValue
raw value
Definition Fitness.idl:42
fitness::Fitness::ErrorLogEntry::powerOnHours
int powerOnHours
power on hours when error occured
Definition Fitness.idl:43
fitness::Fitness::ErrorLogEntry::thresholdValue
int thresholdValue
normalized threshold value
Definition Fitness.idl:41
fitness::Fitness::ErrorLogEntry::id
string id
id of the associated data entry
Definition Fitness.idl:39
fitness::Fitness::ErrorLogEntry::value
int value
normalized value
Definition Fitness.idl:40